﻿using System;
using System.Collections.Generic;
using System.Text;

using Microsoft.Extensions.Logging;
using Microsoft.Extensions.DependencyInjection;

namespace Platform.Modules.Implementation
{
    public class LoggingProvider
    {
        private static IServiceProvider _Provider;

        public static void Initialize( IServiceProvider provider )
        {
            _Provider = provider;
        }

        public static ILogger<T> Create<T>()
        {
            return _Provider?.GetService<ILogger<T>>();
        }

        public static ILogger Create<T>(string name)
        {
            return _Provider?.GetService<ILoggerFactory>().CreateLogger(name);
        }

        public static ILogger Create<T>(Type type)
        {
            return _Provider?.GetService<ILoggerFactory>().CreateLogger(type);
        }
    }
}
